# checks if '$1' (string) is only hex chars
# returns
#    0 if result is true
#    1 if result is false
#    2 on usage error
checkHex(){
	[ -z ${1} ] && p_err "no input" && return 2
	# == +([0-9a-fA-F]) syntax from
	# https://stackoverflow.com/questions/806906/how-do-i-test-if-a-variable-is-a-number-in-bash
	# referenced from http://www.gnu.org/software/bash/manual/bashref.html#Pattern-Matching
	! [[ $1 == +([0-9a-fA-F]) ]] && return 1 || return 0
}
