#! /usr/bin/env bash

# license
#
# /  with this i am 
# 		trying stuff / having fun / relax when i am tinkering 
# /  while learning 
# 		c / bash / zsh / unix tools / ... / programming.
# /  so its very likely, that this is buggy, 
# /  poor style, and other things c-code (or other code) might be, or even unfinished 
# /  or not working...
# /
# /  But take it, and do whatever you want to do with this, learning like i do,
# /  or what you like. Tell me what you do or think about this, if you like at 
# /		hallo@timte.org
# /
# /  so until i know better, i use GPL 3.0 in case i publish this simple thing...
# / 
# /  Copyright (C) 2023 timte
# / 
# /  This program is free software: you can redistribute it and/or modify
# /  it under the terms of the GNU General Public License as published by
# /  the Free Software Foundation, either version 3 of the License.
# / 
# /  This program is distributed in the hope that it will be useful, (or just fun),
# /  but WITHOUT ANY WARRANTY; without even the implied warranty of
# /  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# /  GNU General Public License for more details.
# /  See <https://www.gnu.org/licenses/>.



#      # Manual Password Manager
#
# Decrypt openssl encrypted "indirect passphrase" (or password).
#
#    KeyID,salt, settings,length,indirect_key,padding
#    '----.---'  '----------------.-----------------'
#    unencrypted              encrypted
#
# encoded data is formatted as 6 bit words (hexades/sixtetts). Setting-bits are:
#
#    Bit 1: '1' next block (KeyID) is a subsequent Key. '0' if not.
#    Bit 2: '1' if this block is a subsequend Key. '0' if not.
#    Bit 3-6: Method 0-15

version="2.8.0b (23.7.2023 beta)"

# TODO
# implement version of mpm data structure in first block (18 Bytes, 24 hexades):
#
# mpM: "manually processable MPM-data"
#
# first block is in ASCII
# alternatives:
# [nk 23:36] mpm_script % printf "3Jt3N_MPM_00a_b64_" | base64
# M0p0M05fTVBNXzAwYV9iNjRf
# 012345678901234567890123
# 0        10        20
# [nk 23:36] mpm_script % printf "3Jt3N_MPM_00a__" | base64
# M0p0M05fTVBNXzAwYV9f
# 012345678901234567890123
# 0        10        20
# [nk 10:31] mpm_script % printf "0<timte.org/mpm>v0" | base64
# MDx0aW10ZS5vcmcvbXBtPnYw
# [nk 10:33] mpm_script % printf "0<timte.org/mpm>00" | base64
# MDx0aW10ZS5vcmcvbXBtPjAw
# [nk 10:33] mpm_script % printf "0>timte.org/mpm<00" | base64
# MD50aW10ZS5vcmcvbXBtPDAw
# [nk 16:25] mpm_script % printf "v00|timte.org/mpm" | base64
# djAwfHRpbXRlLm9yZy9tcG0=
# [nk 16:25] mpm_script % printf "0v00|timte.org/mpm" | base64
# MHYwMHx0aW10ZS5vcmcvbXBt
#
# for v in {00..39} ; do printf "3Jt${v}mpm.timte.org\n" ; printf "3Jt${v}mpm.timte.org" | base64 ; done
# 3Jt00mpm.timte.org
# M0p0MDBtcG0udGltdGUub3Jn
# 3Jt01mpm.timte.org
# M0p0MDFtcG0udGltdGUub3Jn
# 3Jt02mpm.timte.org
# M0p0MDJtcG0udGltdGUub3Jn
# [...]
# 3Jt39mpm.timte.org
# M0p0MzltcG0udGltdGUub3Jn
#
# for c in t; do for n in {00..39} {0..3}{a..z} {0..3}{A..Z} ; do s="$(printf "3J${c}${n}mpm.timte.org")"; if printf "%s" "$s" | base64 | grep --color "M0p0M[0-9]"; then printf "%s\n" "$s" >&2 ; fi ; done ; done 
# M0p0M2FtcG0udGltdGUub3Jn
# 3Jt3ampm.timte.org
# M0p0M2JtcG0udGltdGUub3Jn
# 3Jt3bmpm.timte.org
# M0p0M2NtcG0udGltdGUub3Jn
# 3Jt3cmpm.timte.org
# [...]
# 3Jt3Xmpm.timte.org
# M0p0M1ltcG0udGltdGUub3Jn
# 3Jt3Ympm.timte.org
# M0p0M1ptcG0udGltdGUub3Jn
# 3Jt3Zmpm.timte.org
# 012345678901234567890123
# 0        10        20
#
# 3Jt00mpm.timte.org
# M0p0MDBtcG0udGltdGUub3Jn
# 012345678901234567890123
# 0        10        20
# magic2="$(for c in {A..Z} {a..z}; do for n in {00..39} ; do s="$(printf "3J${c}${n}mpm.timte.org")"; printf "%s " "$s" ; printf "%s" "$s" | base64 ; done ; done)"
# echo "$magic2" | wc -l
#    2080
# echo "$magic2" | grep "M0p.M" | wc -l
#    2080
# echo "$magic2" | grep "M0p[0-9]M" | wc -l
#     280
# echo "$magic2" | grep "M0p0M" | wc -l
#      40
# 3Jt00mpm.timte.org M0p0MDBtcG0udGltdGUub3Jn
# 3Jt01mpm.timte.org M0p0MDFtcG0udGltdGUub3Jn
# 3Jt02mpm.timte.org M0p0MDJtcG0udGltdGUub3JnA
# ...
# 3Jt39mpm.timte.org M0p0MzltcG0udGltdGUub3Jn


#### FAVORITE ####
# 3Jt0|mpm.timte.org
# M0p0MHxtcG0udGltdGUub3Jn
# 012345678901234567890123
# 0        10        20
# magic4="$(for c in {A..Z} {a..z}; do for n in {0..9} {A..Z} {a..z} ; do s="$(printf "3J${c}${n}|mpm.timte.org")"; printf "%s " "$s" ; printf "%s" "$s" | base64 ; done ; printf " $c\r"  >&2 ; done)"
# echo "$magic4" | grep "M0p[0-9]M" | wc -l
#      28
#  --> 3J[t-z][0-3]|mpm.timte.org
# echo "$magic4" | grep "M0p.M" | wc -l
#     208
#  --> 3J[A-Za-z][0-3]|mpm.timte.org
# echo "$magic4" | grep "M0p" | wc -l
#    3224
# echo "$magic4" | wc -l
#    3224

#
#
#### Magic Bytes
# '3J' + version number + '|' + 'mpm.timte.org'
#
#### Version Number ordering:
# 1.   t0, t1, t2, t3, u0, u1, u2, u3, .. z3
#    ( n=28, MagicBytes base64 representation M0p[0-6]M...)
# 2.   { { A0 .. A9 ; AA .. AZ ; Aa .. Az } .. Zz } .. { a0 .. sz }
#    ( n = 2790, base64 representation M0p...)
# echo "$magic4" | grep -v "3J[t-z]" | wc -l
#    2790
#
#  example for first version:
#
#      3Jt0|mpm.timte.org
#  or
#      3Jt0|timte.org/mpm
#
# base64 (24 hexades):
#
#      M0p0MHxtcG0udGltdGUub3Jn
# or
#      M0p0MHx0aW10ZS5vcmcvbXBt



printf "[INFO] beta. charlist definitions changed. (hit enter to continue)\n" >&2
sleep 1


## files
mpm_dir="$HOME/.settingsfiles/mpm"
keyDatabase_dir="${mpm_dir}/db"
settingsFile="${mpm_dir}/mpm_settings.json"
default_keyDatabase_filename="keyDB.enc"
keyDatabase_filename=$default_keyDatabase_filename


## import functions, check helper tools
#
#  return values are (maybe not consistently used. sometimes also '1' is an error :/ ):
#     0   if result is true
#     1   if result is false
#     2   on usage error or invalid input

functionsDir="$(dirname $0)/functions" 
helper_tools="$(dirname $0)/helper_tools"

### version specific resources check
needed_versions_ressources=(
	"'${functionsDir}/addIPHRto_iphrArray.sh' md5:c394b96cc4a8a4302dcab0a97e301261"
	"'${functionsDir}/base64_charset.sh' md5:b207868694e3caa9f6a841ea817e64bf"
	"'${functionsDir}/charlist64_decode.sh' md5:c75fdf2ab0a91d84144f6ae38641fb6a"
	"'${functionsDir}/charlist64_encode.sh' md5:83d6151d1c504e8229671d72eb769bd4"
	"'${functionsDir}/charlist64_list_definitions.sh' md5:5a7a1a3654e385c16c2a3904fdf834b5"
	"'${functionsDir}/checkArgLen.sh' md5:5a8c987af4ca72792e17db6a3589d2c0"
	"'${functionsDir}/checkHex.sh' md5:bd2eb973a7a804d02b1a7204c7e94f05"
	"'${functionsDir}/checkOct.sh' md5:cc034d51bdf4d9c61bc9a1925188fccf"
	"'${functionsDir}/checkValid_keyID.sh' md5:628b818bc8077fc7c158bcfb3ca4bb8d"
	"'${functionsDir}/dateMethod_encode.sh' md5:5078427b21ca8f722d160a48711e5280"
	"'${functionsDir}/debugMsg.sh' md5:2196db20edd27cce13a942ef7550e07c"
	"'${functionsDir}/debug_print_hexadesIPHR.sh' md5:8b0b6325a8f96701c82fd42cdb1f7554"
	"'${functionsDir}/decIPHRdateMethod.sh' md5:c78071ad04937255da1e34663f378c51"
	"'${functionsDir}/decodeIPHR.sh' md5:24c1986e21c79416ffafa99cf2a6faf6"
	"'${functionsDir}/decrypt_iphrArrayDB.sh' md5:96ad36f36ba62fa034fb9bc9b074531e"
	"'${functionsDir}/encode_IPHR_input.sh' md5:7fc859299c5f4945a2de65e4632f7e08"
	"'${functionsDir}/exit_f.sh' md5:c5f5e6def754887419ae560e1a8d0d50"
	"'${functionsDir}/fillArr_hexadesIPHR.sh' md5:b4f78966438f85f89494a731c347adf3"
	"'${functionsDir}/get_iphrArrMD5.sh' md5:793ba215dd399938be4f3cb31c85effd"
	"'${functionsDir}/hexDate.sh' md5:a79d11bfb4d6839fa3b80e96fd1bef66"
	"'${functionsDir}/interactive_mode.sh' md5:e63b86fb80505a5becd92b4d48fa2663"
	"'${functionsDir}/optlist.sh' md5:be09102adc147658fca5cae2bfa7a8de"
	"'${functionsDir}/p_err.sh' md5:8c871086fcca02116d8aaf348a4209a8"
	"'${functionsDir}/parseOptions.sh' md5:2578a1e82fac5d2e3abacdcdac4015f4"
	"'${functionsDir}/read_passphrase.sh' md5:950f0065ca402a7b0b72f004daebba26"
	"'${functionsDir}/usage.sh' md5:de66ce3ed858d0b54805e12e4b19376b"
	"'${functionsDir}/wordlist.sh' md5:1b363add9de066cfb3bd8db67d760b2d"
	"'${functionsDir}/write_keyDB.sh' md5:b031038e12e55ef9e6dfe4541c65b3c8"
)
### get above list: % for f in *; do printf "\t\"'\${functionsDir}/$f' md5:%s\"\n" $(md5 -q $f); done

! test -d $functionsDir && echo "[error] could not load functions. Dir not found: '$functionsDir'" >&2 && exit

loaded_ressources=()
for f in "$functionsDir"/*; do
	source "${f}"
	loaded_ressources[${#loaded_ressources[@]}]="'$f' md5:$(md5 -q "$f")"
done
missing_ressources=( $(comm -23 <(printf "%s\n" "${needed_versions_ressources[@]}" | sort) <(printf "%s\n" "${loaded_ressources[@]}" | sort) ) )

### check versions functions and main script.
if [[ "$1" == "-no-chk" ]]; then
	shift
else
	resource_err=0
	(( ${#missing_ressources[@]} ))   \
	    && echo "[error] needed ressouces missing in $functionsDir:" >&2  \
	    && printf "\t%s\n" ${missing_ressources[@]} >&2                   \
	    && resource_err=1
	[[ "$(cat $0 | grep -v 'grepAllButThis' | md5)" != "47fad734eb9e9358085e5cf647982a0d" ]] \
	    && echo "[error] $0 main script changed" >&2                                         \
	    && resource_err=1
	    ### get this md5 by: cat mpm.sh | grep -v 'grepAllButThis' | md5
	(( resource_err ))                                                           \
	    && echo "  (skip ressource checking with: '$0 -no-chk <args> ...')" >&2  \
	    && exit
fi

### check for helper tools or compile
crc16_nk_bin="crc16_nk"
crc16_nk="${helper_tools}/${crc16_nk_bin}"
if ! test -f "$crc16_nk"; then
	p_message "[warning] helper tool not found: '$crc16_nk'"   \
	      "trying to compile from source..."
	pushd "$helper_tools" 1>/dev/null
	! xxd -i "${crc16_nk_bin}.c" > "${crc16_nk_bin}.c.h"                    \
		&& p_err "while producing quine header file '${crc16_nk}.c.h'"  \
		&& exit
	! gcc -o "$crc16_nk_bin" "${crc16_nk_bin}.c"                            \
		&& p_err "while compiling '${crc16_nk_bin}'"                    \
		&& exit
	rm "${crc16_nk_bin}.c.h"
	pushd 1>/dev/null
fi
edit_json="${helper_tools}/edit_json.py"
if test -f "$edit_json"; then
	if test -f "$settingsFile"; then
		keyDatabase_filename=$($edit_json "$settingsFile" "dbFileName")
	else
		mkdir -p "$keyDatabase_dir"
		echo "{ \"dbFileName\": \"$keyDatabase_filename\" }" > "$settingsFile"
	fi
else
	p_message "[warning] helper tool not found: '$edit_json'"   \
	          "  Using default database: $keyDatabase_filename"
fi
keyDatabase="${keyDatabase_dir}/${keyDatabase_filename}"
keysAssignmentFile="${keyDatabase_dir}/${keyDatabase_filename:0: -4}a.enc"

### check openssl version
openssl_min_vers="LibreSSL 3.6.2"
openssl_min_vers_ref="${openssl_min_vers:0: -1}1.999 (mpm_reference)" 
openssl_installed="$(openssl version 2>/dev/null)"
openssl_newer_version="$(printf "%s\n" "$openssl_installed" "$openssl_min_vers_ref" | sort -k 2 | tail -1)"
[[ "$openssl_installed" == "" ]] && p_err "Install at least OpenSSL $openssl_min_vers" && exit
[[ "$openssl_newer_version" == "" ]] && p_err "OpenSSL version check failed." && exit
if [[ "$openssl_newer_version" == "$openssl_min_vers_ref" ]]; then
	p_message "[Warning] $0 is based on at least '$openssl_min_vers'." \
	          "Installed is: '$openssl_installed'"                     \
	          "Maybe works with OpenSSL or earlier versions,"          \
		  "but it's recommended to install the current LibreSSL." ""
	sleep 2
fi

#
##### END import functions, check helper tools


! parseOptions "$@" && exit

debugMsg "keyDatabase is: '$keyDatabase'" "keysAssignmentFile: '$keysAssignmentFile'"

main(){
	debugMsg "BEGIN $FUNCNAME"
	if (( opt_encode )); then
		encode_IPHR_input || return 1
	elif (( opt_decode )); then
		if (( directDecode )) ; then
			keyID=0
			iphrArray_isDecrypted=0 # need new decryption if directDecode used in interactive_mode
			echo "direct decoding."
		else
			decrypt_iphrArrayDB || return 1
		fi
		decodeIPHR || return 1
		(( keysCounter <= keyID )) && p_message "No such keyID. Total number of keyIDs is $keysCounter" && return 1
	elif (( opt_list )); then
		decrypt_iphrArrayDB || return 1
		echo "$keysAssignmentList"
		if (( opt_interactive )); then
			printf "\n(hit a key to continue)"
			read -n 1 answer
			echo
		fi
	else
		debugMsg "no option set to do anything in main..."
	fi
	debugMsg "END $FUNCNAME"
	return 0
}

if (( opt_interactive )); then
	interactive_mode
	exit_f
fi

main

exit_f
