# checks if '$1' (str) has length '$2' (num)
# returns
#    0 if result is true
#    1 if result is false
#    2 on usage error
checkArgLen(){
	if ( ( ! [[ $2 =~ ^[0-9]*$ ]] ) || [ -z "$2" ] ); then
		p_err "invalid number"
		return 2
	fi
	(( ${#1} != $2 )) && return 1 || return 0
}
