choose_database(){
	db_arr=()
	i=0
	printf "Current database: '$(basename "$keyDatabase")'\n"
	while read f; do
		db_arr[i]="$f"
		((i++))
		printf "[%02d]: '${db_arr[i-1]}'\n" $i
	done <<< $(ls -1 "$keyDatabase_dir" | grep 'keyDB\.' | grep -v "^$(basename "$keyDatabase")$")
	printf "choose a database number or 'n' for a new one ('c' to cancel): "
	read choice
	while [[ "$choice" != +([nc]) ]] \
	      && ( [[ $choice != +([0-9]) ]] \
		       || (( choice < 1 | choice > ${#db_arr[@]} ))
		); do
		printf "Not a valid choice, choose again ('c' to cancel): "
		read choice
		[[ "$choice" == "n" ]] && break
	done
	[[ "$choice" == "c" ]] && return 0
	if [[ "$choice" != "n" ]]; then
		keyDatabase_filename="${db_arr[choice-1]}"
	else
		while [[ "$keyDatabase" == "${keyDatabase_dir}/${keyDatabase_filename}" ]]; do
			printf "type new database name (or nothing and 'enter' to cancel): "
			read new_DB_name
			[[ "$new_DB_name" == "" ]] && return 0
			keyDatabase_filename="${new_DB_name}_${default_keyDatabase_filename}"
		    test -f "${keyDatabase_dir}/${keyDatabase_filename}" \
				&& printf "Database already exists.\n"           \
				&& keyDatabase="${keyDatabase_dir}/${keyDatabase_filename}"
		done
	fi
	if test -f "$edit_json"; then
		$edit_json "$settingsFile" "dbFileName" "$keyDatabase_filename" 1>/dev/null
	fi
	keyDatabase="${keyDatabase_dir}/${keyDatabase_filename}"
	keysAssignmentFile="${keyDatabase_dir}/${keyDatabase_filename:0: -4}a.enc"		
	p_message "Database file:" "'$keyDatabase'"
	(( opt_interactive )) && iphrArray=() && iphrArray_isDecrypted=0 && sleep 3
	return 0
}
